# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import gamethread

import os
import re

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "C4Timer by L'In20Cible"
g_informations["version"] = "1.0"
g_informations["date"] = "2010-05-14"
g_informations["author"] = "L\'in20Cible"
g_informations["url"] = "http://addons.eventscripts.com/addons/view/c4timer/"
g_informations["basename"] = "c4timer"

es.ServerVar("ct_version", (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_progress = False
mp_c4timer = es.ServerVar("mp_c4timer")
es_gamedir = str(es.ServerVar("eventscripts_gamedir"))

g_options = {
   "enable": ("1", "ct_enable <1/0> -- Active/Désactive le compte à rebours."),
   "screen": ("1", "ct_screen <1/0> -- Active/Désactive l'affichage visuel."),
   "sounds": ("1", "ct_sounds <1/0> -- Active/Désactive le compte à rebours sonore.")
   }
for option in g_options:
   g_options[option] = es.ServerVar(("ct_" + option), g_options[option][0], g_options[option][1])


# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   Initialization()
   
   
def Initialization():
   path = GetConfigurationFilePath("configuration.cfg")
   if os.path.isfile(path):
      es.mexec(path.replace(es_gamedir, ".."))
   path = GetConfigurationFilePath("downloads.txt")
   if not os.path.isfile(path) or not str(es.ServerVar("eventscripts_currentmap")):
      return
   regex = re.compile("//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\n)+")
   for line in open(path):
      line = regex.sub("", line).strip()
      if not line:
         continue
      es.stringtable("downloadables", line)
      
      
def unload():
   if not g_progress:
      return
   gamethread.cancelDelayed("c4timer")
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetConfigurationFilePath(file):
   return os.path.join(es_gamedir, "addons", "eventscripts", g_informations["basename"], "configuration", file).replace(os.sep, "/")


def PlayC4TimerSound(time):
   if not int(g_options["enable"]) or not int(g_options["sounds"]) or not os.path.isfile(os.path.join(es_gamedir, "sound", g_informations["basename"], (str(time) + ".wav")).replace(os.sep, "/")):
      return
   for userid in es.getUseridList():
      if es.isbot(userid):
         continue
      es.playsound(userid, os.path.join(g_informations["basename"], (str(time) + ".wav")).replace(os.sep, "/"), 1.0)
      
      
def SendC4TimerOverlay(time):
   if not int(g_options["enable"]) or not int(g_options["screen"]) or not os.path.isfile(os.path.join(es_gamedir, "materials", "overlays", g_informations["basename"], (str(time) + ".vmt")).replace(os.sep, "/")):
      return
   for userid in es.getUseridList():
      if es.isbot(userid):
         continue
      es.cexec(userid, ("r_screenoverlay %s" % os.path.join("overlays", g_informations["basename"], str(time)).replace(os.sep, "/")))
   

# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def C4TimerCallBack(time):
   if not g_progress or (time < 0):
      return
   PlayC4TimerSound(time)
   SendC4TimerOverlay(time)
   gamethread.delayedname(1, "c4timer", C4TimerCallBack, (time - 1))
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   global g_progress
   Initialization()
   if not g_progress:
      return
   g_progress = False
   
   
def bomb_exploded(event_var):
   global g_progress
   if not g_progress:
      return
   g_progress = False
   SendC4TimerOverlay(0)
   
   
def bomb_defused(event_var):
   global g_progress
   if not g_progress:
      return
   g_progress = False
   
   
def bomb_planted(event_var):
   global g_progress
   if not int(g_options["enable"]) or g_progress:
      return
   g_progress = True
   C4TimerCallBack(int(mp_c4timer))
   
   
def round_start(event_var):
   for userid in es.getUseridList():
      if es.isbot(userid):
         continue
      es.cexec(userid, "r_screenoverlay \"\"")